% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qseed.R
\name{qseed}
\alias{qseed}
\title{Set the random number generator for the rlecuyer package}
\usage{
qseed(jobNum = 1, jobTot = 1, parSeed = rep(1124, 6))
}
\arguments{
\item{jobNum}{The index of the current stream, relative to the total number of streams
to be requested.}

\item{jobTot}{The total number of streams to be requested.}

\item{parSeed}{A vector of 6 integers.}
}
\description{
Set the random number stream given a parallel seed for the relecuyer package (6 integers), a number
  of total parallel streams, and the current parallel stream.
}
\details{
The seed is set using \code{\link{.lec.SetPackageSeed}}.  The current
 stream is determined by \code{jobNum} and then stream \code{jobNum} is
 started using \code{\link{.lec.CreateStream}}, and \code{\link{.lec.CurrentStream}}.
}
